<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class SmPercentualMaximoDescontoAcrescimoOperadorFactory {

    protected $connection;
    
    public function __construct(EntityManager $entityManager) {    
        $this->connection = $entityManager->getConnection();
    }

    public function getPercentualDescontoAcrescimo(array $params) {
        $sql = "SELECT NVL(DESCONTO.VRPERCENTUALOPER, DESCONTO.VRPERCENTUALPERF) AS VRPERCDESC,
                       DESCONTO.CDSERVORCA,
                       DESCONTO.TIPO,
                       SERVICO.NMSERVORCA
                 FROM (
                    SELECT MAX(VRPERCENTUAL) AS VRPERCENTUALPERF,
                           NULL AS VRPERCENTUALOPER,
                           CDSERVORCA,
                           2 AS TIPO,
                           NRORG
                      FROM FCT_PERCDESCPERFIL
                     WHERE NRPERFILACESSO IN (SELECT NRPERFILACESSO 
                                                FROM PERFACESSPARC 
                                               WHERE NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                                                         FROM OPERADOR 
                                                                        WHERE CDOPERADOR = :CDOPERADOR))
                       AND (CDSERVORCA = :CDSERVORCA
                        OR CDSERVORCA IS NULL)
                       AND IDTIPO = :IDTIPO
                       AND NRORG = :NRORG
                     GROUP BY CDSERVORCA,
                              NULL,
                              2,
                              NRORG
                    UNION ALL 
                    SELECT NULL AS VRPERCENTUALPERF,
                           VRPERCDESC AS VRPERCENTUALOPER,
                           CDSERVORCA,
                           1 AS TIPO,
                           NRORG
                      FROM FCT_PERCDESCOPER
                     WHERE NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                               FROM OPERADOR 
                                              WHERE CDOPERADOR = :CDOPERADOR)
                       AND (CDSERVORCA = :CDSERVORCA
                        OR CDSERVORCA IS NULL)
                       AND IDTIPO = :IDTIPO
                       AND NRORG = :NRORG
                    ) DESCONTO
                    INNER JOIN FCT_SERVICOORCA SERVICO
                       ON DESCONTO.CDSERVORCA = SERVICO.CDSERVORCA
                      AND DESCONTO.NRORG      = SERVICO.NRORG
               ORDER BY TIPO, CDSERVORCA, VRPERCDESC DESC";
        
        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
        return $ps->fetchAll();
    }
    
    public function getServicosComPercentualDescontoPermitido(array $params, $servicos) {
        $sql = "SELECT NVL(DESCONTO.VRPERCENTUALOPER, DESCONTO.VRPERCENTUALPERF) AS VRPERCDESC,
                       DESCONTO.CDSERVORCA,
                       SERV.NMSERVORCA,
                       DESCONTO.TIPO
                  FROM (
                    SELECT MAX(VRPERCENTUAL) AS VRPERCENTUALPERF,
                           NULL AS VRPERCENTUALOPER,
                           CDSERVORCA,
                           2 AS TIPO,
                           NRORG
                      FROM FCT_PERCDESCPERFIL
                     WHERE NRPERFILACESSO IN (SELECT NRPERFILACESSO 
                                                FROM PERFACESSPARC 
                                               WHERE NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                                                         FROM OPERADOR 
                                                                        WHERE CDOPERADOR = :CDOPERADOR))
                       AND CDSERVORCA IN ($servicos)
                       AND IDTIPO     = 'D'
                       AND NRORG      = :NRORG
                     GROUP BY CDSERVORCA, NULL, 2, NRORG
                     UNION ALL 
                    SELECT NULL AS VRPERCENTUALPERF,
                           VRPERCDESC AS VRPERCENTUALOPER,
                           CDSERVORCA,
                           1 AS TIPO,
                           NRORG
                      FROM FCT_PERCDESCOPER
                     WHERE NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                               FROM OPERADOR 
                                              WHERE CDOPERADOR = :CDOPERADOR)
                       AND CDSERVORCA IN ($servicos)
                       AND IDTIPO     = 'D'
                       AND NRORG      = :NRORG
                ) DESCONTO
                INNER JOIN FCT_SERVICOORCA SERV
                   ON DESCONTO.CDSERVORCA = SERV.CDSERVORCA
                  AND DESCONTO.NRORG      = SERV.NRORG
                ORDER BY VRPERCDESC DESC, CDSERVORCA";

        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
        return $ps->fetchAll();
    }
}