<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctSuspenderParcelasFatura {
    
    const NOME = "FCT_SUSPENDER_PARCELAS_FATURA";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $nrorg, $dtsuspensao = null) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        $procedure->addParam(new Param("P_NRSEQCONTRATO", Param::PARAM_INPUT, $nrseqcontrato, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",         Param::PARAM_INPUT, $nrorg,         Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_DTSUSPENSAO",   Param::PARAM_INPUT, $dtsuspensao,   Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
}

?>