/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NATUASSUOPER                                             */
/* Tabela : NATUASSUOPER                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 18/08/2004 - Andr Rodrigo                                                 */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_NATUASSUOPER'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_NATUASSUOPER
GO

CREATE TRIGGER DTULTATU_NATUASSUOPER
ON NATUASSUOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'NATUASSUOPER', null, 'CDOPERADOR=' + CDOPERADOR + ';' +
                                                      'CDNATUASSU=' + CDNATUASSU + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE NATUASSUOPER
      SET DTULTATUNASO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(NATUASSUOPER.CDOPERADOR,0) = ISNULL(INSERTED.CDOPERADOR,0)) AND
            (ISNULL(NATUASSUOPER.CDNATUASSU,0) = ISNULL(INSERTED.CDNATUASSU,0)) ;
   END;
END;
GO
